# s-process-bar使用文档

s-process-bar是Serverless-Devs-Tool的一个官方组件，通过该组件，可以为项目增加进度条相关能力。

## 使用方法

首先需要导入Pacakge：

```
import {ProgressService, ProgressType, ProgressBarOptions} from 's-progress-bar';
```

以`@serverless-devs/s`重的下载功能为例：

```
async proxyDownload(url: string, dest: string, options: download.DownloadOptions) {
    logger.info('prepare downloading');
    let headers, len;
    try {
      const {h} = await got(url, {method: 'HEAD'});
      headers = h;
      len = parseInt(headers['content-length'], 10);
    } catch (err) {
      // ignore error
    }
    // console.log(len);

    let bar :ProgressService;
    if (len) {
      let pbo :ProgressBarOptions = {
        total: len
      };
      bar = new ProgressService(ProgressType.Bar, pbo);
    } else {
      let pbo :ProgressBarOptions = {
        total: 120,
        width: 30
      };
      let format = `((:bar)) ${green(':loading')} ${green('downloading')} `;
      bar = new ProgressService(ProgressType.Loading, pbo, format);
    }

    logger.info('start downloading');
    await download(url, dest, options).on(
      'downloadProgress', progress => {
        // console.log(progress.transferred);
        bar.update(progress.transferred);
      });
    // clear progress bar
    bar.terminate();
  }
```